// touchCtrlETestMin.js

// 20190919 - allObjects - variables:  /  / 

SPI1.setup({sck:A5, miso:A6, mosi:A7, baud: 2000000}); // SPI1 for touch control
var touch = require("XPT2046E").connect(SPI1, A3,  A2, function(x, y, t) { // callback
      if (x !== undefined) { console.log(x, y); } else { console.log("-----up"); }
      console.log(t);
    }, function(yr, xr, t) { // calibrated touch function
      return [ Math.round(xr / -121.44          + 259.70685111989) 
             , Math.round(yr /   88.90357142857 + -19.78130398103)
             , t ];
    }, 50);
touch.listen();        // not applicable for ADS7843 / Touchscreen modules
