// touchRDTest2.js

// 20190919 - allObjects - variables:  /  / 

// get 
var touchMod = require("touchRD");

// callback
function cb(x, y, t) {
  if ( x !== undefined) { // or: if (t.t) {...
    // for Landscape (90 degrees cc-wise):
    x = t.y; y = t.XH - t.x; // Landscape
    console.log(x, y, t.t);
  } else {
    console.log("up");
  }
}

var touch = touchMod.connect(
    A7 // yp / Y+
  , A6 // xp / X+
  , A5 // yn / Y-
  , A3 // xn / X-
  , cb
  , { ti: 50  // to track touch every 50 [ms]
    , YH: 335 // enable bottom porch / screen overlap
    }
  );

function probe() {
  touch.xy(touch.cb);
}

function onInit() {
  touch.listen();
}

onInit();